# setup everything for the cutscene

scoreboard players set @s cutscene 0
# tag @e[tag=circus_controller] remove unlocked_monkey
execute @e[type=spark:elephant] ~ ~ ~ function yeet
execute @s -374 13 -215 execute @e[type=spark:monkey,tag=!tamed,r=2] ~ ~ ~ function yeet

# summon entities and prepare players
fill -367 16 -191 -381 27 -191 barrier 0 replace fire
summon spark:elephant -374 14 -230
effect @a[tag=!in_tutorial] blindness 5 0 true
scoreboard players set @s a 2
tp @a[tag=!in_tutorial] -374 21 -156 180 13

# anchor armor stand
function boss/circus/cutscene/tag_armorstands

# sandbags
function boss/circus/spawn_sandbags
# kill ones in the way
execute @s -374 30 -206 kill @e[type=spark:sandbag,r=1]
execute @s -374 30 -176 kill @e[type=spark:sandbag,r=1]

tag @e[type=spark:monkey,tag=tamed] add stop_moving
tag @a[tag=!in_tutorial] add in_cutscene

title @a[tag=in_cutscene] times 0 40 120
title @a[tag=in_cutscene] subtitle §fDefeat the mysterious elephant!
title @a[tag=in_cutscene] title §6§l- Circus -

# set light from glass panes
execute @s -374 37 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 glass_pane 0 replace end_rod 0
execute @s -374 38 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 glass_pane 0 replace end_rod 0
execute @s -374 39 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 glass_pane 0 replace end_rod 0
execute @s -374 40 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 glass_pane 0 replace end_rod 0
execute @s -374 41 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 glass_pane 0 replace end_rod 0
execute @s -374 42 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 glass_pane 0 replace end_rod 0
execute @s -374 43 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 glass_pane 0 replace end_rod 0
execute @s -374 44 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 glass_pane 0 replace end_rod 0
execute @s -374 45 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 glass_pane 0 replace end_rod 0

#elephant gate
clone -389 14 -237 -395 20 -237 -377 14 -223
#front gate on
tag @e[type=spark:circus_gate] remove open
fill -377 14 -152 -371 20 -152 barrier
#cage cage
clone -330 18 -195 -325 26 -191 -377 22 -217
summon spark:monkey -375 25 -214
setblock -374 25 -215 light_block 12
#cage floor empty
clone -326 14 -185 -320 22 -179 -377 12 -218

#clear throwables pre fight
# clear @a[tag=!in_tutorial] egg
# clear @a[tag=!in_tutorial] arrow
# clear @a[tag=!in_tutorial] experience_bottle
# clear @a[tag=!in_tutorial] ender_pearl
# scoreboard players set @a[tag=!in_tutorial] cooldown_1 714

# clear armor for some reason..?
function boss/cutscene/clear_armor

# rmove basic zombies
execute @e[type=spark:basic_zombie] ~ ~ ~ function yeet

tag @s remove endMusic
# music
playsound music.circus.intro @a[tag=in_cutscene]
scoreboard players set @s musicTimer 440

tag @e[tag=id_check] add bossfight_active
tag @e[tag=circus_controller] add cutscene_active

# beacon
execute @e[type=spark:beacon,x=-374,y=14,z=-153,r=2] ~ ~ ~ function yeet


function boss/remove_placeables