# executed as junkyard_controller

# get ready for next step
scoreboard players set @s cutscene 0
scoreboard players set @s a 2

# failsafe: remove existing pickups.
execute @e[type=spark:broken_truck] ~ ~ ~ function yeet
execute @e[type=spark:tire_stack] ~ ~ ~ function yeet
execute @e[type=spark:fuel_can] ~ ~ ~ function yeet
execute @e[type=spark:truck_engine] ~ ~ ~ function yeet
execute @e[type=spark:truck_spikes] ~ ~ ~ function yeet

# summon new pickups for the fight
summon spark:broken_truck -223 15 103
execute @e[type=spark:broken_truck] ~ ~ ~ tp @s ~ ~.1 ~ -90 0
summon spark:tire_stack -220 14 108
summon spark:fuel_can -248 23 109
summon spark:truck_engine -212 7 79
summon spark:truck_spikes -255 20 37

tag @e[type=spark:monkey,tag=tamed] add stop_moving
tag @a[tag=!in_tutorial] add in_cutscene

# setup players for the fight
effect @a[tag=in_cutscene] blindness 5 0 true
title @a[tag=in_cutscene] times 0 40 120
title @a[tag=in_cutscene] subtitle §fFix the truck!
title @a[tag=in_cutscene] title §6§l- Junkyard -
tellraw @a[tag=in_cutscene] {"rawtext":[{"text":"§6§l[!] §rGo to the §6beacons§r, §6collect the parts§r, §6repair the truck §rand §6escape §rthe junkyard."}]}
tp @a[tag=in_cutscene] -212.0 19.0 103.0 90.0 30.0

# close the gate
clone -215 1 119 -209 5 114 -215 14 114

# reset the exit gate
kill @e[type=spark:junkyard_gate]
fill -225 9 14 -217 14 14 barrier
summon spark:junkyard_gate -221 9 14

# activate beacons
setblock -220 13 108 stained_glass 4
setblock -248 13 109 stained_glass 4
setblock -212 6 79 stained_glass 4
setblock -255 19 37 stained_glass 4

# replace removed beacons
setblock -212 4 79 beacon
setblock -220 12 108 beacon
setblock -255 13 37 beacon
setblock -248 12 109 beacon

#clear throwables pre fight
# clear @a[tag=!in_tutorial] egg
# clear @a[tag=!in_tutorial] arrow
# clear @a[tag=!in_tutorial] experience_bottle
# clear @a[tag=!in_tutorial] ender_pearl
# scoreboard players set @a[tag=!in_tutorial] cooldown_1 938

# clear player armor?
function boss/cutscene/clear_armor

# kill all zombies
execute @e[type=spark:basic_zombie] ~ ~ ~ function yeet

tag @e[tag=id_check] add bossfight_active
tag @e[tag=junkyard_controller] add cutscene_active

# music
tag @s remove endMusic
playsound music.junkyard.intro @a[tag=in_cutscene]
scoreboard players set @s musicTimer 960

# beacon
execute @e[type=spark:beacon,x=-212,y=14,z=115,r=2] ~ ~ ~ function yeet