# run as junkyard controller if no more players are in the junkyard during the fight

# remove key item entities & reset junkyard to idle
scoreboard players set @e[tag=junkyard_controller] a 0
kill @e[type=spark:tire_stack]
kill @e[type=spark:fuel_can]
kill @e[type=spark:truck_engine]
kill @e[type=spark:truck_spikes]

# open entrance
clone -215 6 119 -209 10 114 -215 14 114
# close exit
execute @e[tag=junkyard_controller,tag=!unlocked_gate] ~ ~ ~ kill @e[type=spark:junkyard_gate]
execute @e[tag=junkyard_controller,tag=!unlocked_gate] ~ ~ ~ fill -225 9 14 -217 14 14 barrier
execute @e[tag=junkyard_controller,tag=!unlocked_gate] ~ ~ ~ summon spark:junkyard_gate -221 9 14

# keep the gate open if they have unlocked already
execute @e[tag=junkyard_controller,tag=unlocked_gate] ~ ~ ~ fill -225 9 14 -217 14 14 air
execute @e[tag=junkyard_controller,tag=unlocked_gate] ~ ~ ~ tag @e[type=spark:junkyard_gate] add open

# replace removed beacons
setblock -212 4 79 beacon
setblock -220 12 108 beacon
setblock -255 13 37 beacon
setblock -248 12 109 beacon

# close beacons
setblock -220 13 108 dirt
setblock -248 13 109 dirt
setblock -212 6 79 cobblestone
setblock -255 19 37 gravel

# remove dropped items
execute @e[type=item] ~ ~ ~ detect ~ 0 ~ diamond_block -1 kill @s
execute @e[type=spark:truck] ~ ~ ~ detect ~ 0 ~ diamond_block -1 kill @s

# reset players
# spawnpoint @a[tag=!in_tutorial] -187 15 108
execute @e[type=spark:basic_zombie] ~ ~ ~ function yeet
function boss/junkyard/clear_items

function other/unlock_safehouse

# beacon
execute @e[type=spark:beacon,x=-212,y=14,z=115,r=2] ~ ~ ~ function yeet
summon spark:beacon -212 14 115 area:junkyard