# run from a commandblock once per second / every 20 ticks.

execute @e[tag=yeet] ~ ~ ~ kill @s[y=-40,dy=10]

#spawning/zombie controllers
execute @e[tag=id_check,tag=!bossfight_active] ~ ~ ~ function other/grave_control/check
# scoreboard players set @e[tag=id_check] i 0
# execute @e[tag=boss_controller,scores={a=1..}] ~ ~ ~ scoreboard players set @e[tag=id_check] i 1
# execute @e[tag=id_check,tag=!bossfight_active] ~ ~ ~ function other/grave_control/a
execute @e[tag=id_check,tag=bossfight_active] ~ ~ ~ tag @e[type=spark:grave,tag=!override] add override
# function other/zombie_tagging
function other/zombie_removal

# tutorial
execute @a[x=-134,y=19,z=85,dx=50,dy=20,dz=70,c=1] ~ ~ ~ execute @e[tag=tutorial] ~ ~ ~ function tutorial/main

# boss particles
#execute @e[tag=id_check,tag=!bossfight_active] ~ ~ ~ function boss_particles_slow
execute @e[tag=id_check,scores={a=3..}] ~ ~ ~ particle spark.zombies:boss.reset.south -195 16.5 117
execute @e[tag=id_check,scores={a=..1}] ~ ~ ~ execute @e[type=spark:beacon,x=-740,y=30,z=92,r=3,tag=!locked] ~ ~ ~ function boss/pres/unlock/lock
execute @e[tag=id_check,scores={a=2..}] ~ ~ ~ execute @e[type=spark:beacon,x=-740,y=30,z=92,r=3,tag=locked] ~ ~ ~ function boss/pres/unlock/unlock

#player armor. don't run if bossbattle is in cutscene
scoreboard players add @e[tag=id_check] armor_timer 1
execute @e[tag=id_check,scores={armor_timer=10..}] ~ ~ ~ function other/armor/main

# respawn zappack on back
# execute @a[tag=has_zappack,tag=!spectator,tag=!in_cutscene,tag=!add_zappack] ~ ~ ~ function zappack/regive

# return any lost trident/rockets
execute @a[tag=has_rocket,tag=!add_rocket,scores={rocketCheck=0}] ~ ~ ~ function rocket/regive
# remove tridents
clear @a[scores={rocketCheck=1},tag=!has_rocket] trident

# remove packs on people in cutscenes etc backs
execute @a[tag=!in_tutorial,tag=in_cutscene] ~ ~ ~ execute @e[type=spark:zappack,r=2] ~ ~ ~ function yeet

# monkey back to owner helper
# execute @a[tag=tamer,tag=!make_spectator,tag=!spectator,tag=!in_cutscene] ~ ~ ~ function monkey/back_to_owner

# remove zombies that are above a bone_block
execute @e[r=15,x=-200,y=14,z=125,type=spark:acrobat_zombie] ~ ~ ~ detect ~ 12 ~ bone_block -1 function yeet
execute @e[r=15,x=-200,y=14,z=125,type=spark:agent_zombie] ~ ~ ~ detect ~ 12 ~ bone_block -1 function yeet
execute @e[r=15,x=-200,y=14,z=125,type=spark:basic_zombie] ~ ~ ~ detect ~ 12 ~ bone_block -1 function yeet
execute @e[r=15,x=-200,y=14,z=125,type=spark:clown_zombie] ~ ~ ~ detect ~ 12 ~ bone_block -1 function yeet
execute @e[r=15,x=-200,y=14,z=125,type=spark:fat_zombie] ~ ~ ~ detect ~ 12 ~ bone_block -1 function yeet
execute @e[r=15,x=-200,y=14,z=125,type=spark:jetpack_zombie] ~ ~ ~ detect ~ 12 ~ bone_block -1 function yeet
execute @e[r=15,x=-200,y=14,z=125,type=spark:military_zombie] ~ ~ ~ detect ~ 12 ~ bone_block -1 function yeet
execute @e[r=15,x=-200,y=14,z=125,type=spark:president_zombie] ~ ~ ~ detect ~ 12 ~ bone_block -1 function yeet
execute @e[r=15,x=-200,y=14,z=125,type=spark:segway_zombie] ~ ~ ~ detect ~ 12 ~ bone_block -1 function yeet
execute @e[r=15,x=-200,y=14,z=125,type=spark:tank_zombie] ~ ~ ~ detect ~ 12 ~ bone_block -1 function yeet
execute @e[r=15,x=-200,y=14,z=125,type=spark:tnt_zombie] ~ ~ ~ detect ~ 12 ~ bone_block -1 function yeet
execute @e[r=15,x=-200,y=14,z=125,type=spark:vomit_zombie] ~ ~ ~ detect ~ 12 ~ bone_block -1 function yeet
execute @e[r=15,x=-200,y=14,z=125,type=spark:zombee] ~ ~ ~ detect ~ 12 ~ bone_block -1 function yeet
execute @e[r=15,x=-200,y=14,z=125,type=spark:zombie_head] ~ ~ ~ detect ~ 12 ~ bone_block -1 function yeet

# remove junkyard items while junkyard isn't active
execute @e[tag=junkyard_controller,scores={a=..0}] ~ ~ ~ function boss/junkyard/clear_items

# remove slowness effect from placeable entities
effect @e[type=spark:shelf_item] slowness 0
effect @e[type=spark:parachute_package] slowness 0
effect @e[type=spark:broken_truck] slowness 0
effect @e[type=spark:truck] slowness 0
effect @e[type=spark:trash_can] slowness 0
effect @e[type=spark:street_sign] slowness 0
effect @e[type=spark:sandbag] slowness 0
effect @e[type=spark:monkey] slowness 0
effect @e[type=spark:placeable_0] slowness 0
effect @e[type=spark:placeable_1] slowness 0
effect @e[type=spark:placeable_2] slowness 0
effect @e[type=spark:placeable_3] slowness 0

# give players in spawn area saturation
effect @a[x=-198,y=46,z=119,dx=22,dy=4,dz=33] saturation 1 10 true
effect @a[x=-198,y=46,z=119,dx=22,dy=4,dz=33] instant_health 1 10 true

# check players time alive for health boost mechanic
function respawn/count_down

# elevators
execute @e[tag=elevator] ~ ~ ~ function other/elevator

# lock safehouse during bossfights
execute @e[tag=id_check,tag=bossfight_active] ~ ~ ~ function other/lock_safehouse

# truck spawning title
execute @e[tag=junkyard_controller,tag=unlocked_gate] ~ ~ ~ particle spark.zombies:spawn_truck.rotate -186 15.5 126

# scribbles particles
particle spark.zombies:scribble_bosses.east -192.98 18.3 112
particle spark.zombies:scribble_statue.west -180.02 17.5 111.0
particle spark.zombies:scribble_truck.west -181.02 15.1 125.5
particle spark.zombies:scribble_gear.north -194.5 15.6 122.97

# settings particles
particle spark.zombies:difficulty.easy -183 17.7 100
particle spark.zombies:difficulty.normal -183 17.7 102
particle spark.zombies:difficulty.hard -183 17.7 104

particle spark.zombies:device_setting.east -191 18.1 102

particle spark.zombies:platform.mobile.east -191 17.5 104.45
particle spark.zombies:platform.console.east -191 17.5 102
particle spark.zombies:platform.computer.east -191 17.5 100.2

execute @e[tag=id_check,scores={difficulty=0}] ~~~ particle spark.zombies:difficulty.easy.selected -183 17.7 100
execute @e[tag=id_check,scores={difficulty=1}] ~~~ particle spark.zombies:difficulty.normal.selected -183 17.7 102
execute @e[tag=id_check,scores={difficulty=2}] ~~~ particle spark.zombies:difficulty.hard.selected -183 17.7 104

# particle spark.zombies:difficulty.base -183 17.7 122
# particle spark.zombies:difficulty.base.selected -183 17.7 122
# Difficulty name particles in master.mcfunction

# paintings
function boss/pres/paintings

# player counting
execute @e[tag=id_check] ~ ~ ~ function other/multiplayer_scaling

# player regeneration
execute @e[tag=id_check,scores={difficulty=0..1}] ~ ~ ~ execute @a ~ ~ ~ function other/regeneration

# make sure in_tutorial tag is properly removed
tag @a[tag=in_safehouse] remove in_tutorial
execute @a ~~~ tag @s[x=-800,dx=600] remove in_tutorial