# commandblocks and entities can be found at -160 4 105
# id_check is an armorstand
# all 4 controllers have the boss_controller tag as well as their own respective tag. 4 armorstands. 

# function is called every tick from a commandblock

#### scores
# boss_controller:
# a: Status of the fight. -1: completed. 0: idle, 1: cutscene, 2+: active
# b: ?
# c: ?
# d: ?
# e: ?

# id_check:
# a: How many bosses have been beaten - 1.
# b: ?
# c: ?
# d: ?
# e: garage door status
# i: status whether bossbattle is active or not.
# k: graves activation timer

# players:
# a: ?
# b: ?
# c: ?
# d: ?
# e: ?
# id: ?
# check: ?
# i: ?

#init players
execute @a[tag=!init] ~ ~ ~ function init_player

# move players out of respawn box to the correct position
function respawn/respawn

# safehouse tagging
tag @a[tag=in_safehouse] remove in_safehouse
tag @a[x=-198,y=14,z=105,dx=17,dy=5,dz=30,tag=!in_safehouse] add in_safehouse

#placeables
execute @e[type=spark:placeable_1] ~ ~ ~ function other/mower
execute @e[type=spark:placeable_2] ~ ~ ~ function other/sprayer

# tip messages
execute @e[tag=id_check] ~ ~ ~ function other/messages/tip_messages

# cutscene helpers
execute @r[tag=in_cutscene] ~ ~ ~ function boss/cutscene/cutscene_helpers
# cutscene skipping
execute @e[tag=boss_controller,tag=cutscene_active,c=1] ~~~ function boss/cutscene/skip/run

# boss controlers
scoreboard players set @a[tag=!in_tutorial] bossfightStatus 0

execute @e[tag=junkyard_controller,scores={a=0..}] ~ ~ ~ function boss/junkyard/controller
execute @e[tag=circus_controller,scores={a=0..}] ~ ~ ~ function boss/circus/controller
execute @e[tag=pplant_controller,scores={a=0..}] ~ ~ ~ function boss/pplant/controller
execute @e[tag=id_check,scores={a=2..}] ~ ~ ~ execute @e[tag=pres_controller,scores={a=-1..}] ~ ~ ~ function boss/pres/controller

#boss rewards
#junkyard
execute @e[tag=junkyard_controller,tag=unlocked_gate] ~ ~ ~ function other/garage

#circus
# monkey spawning
execute @e[tag=id_check,tag=!bossfight_active] -374 13 -215 execute @p[r=24] ~ ~ ~ execute @e[tag=circus_controller,tag=unlocked_monkey] -374 13 -215 function monkey/proximity

#scientist

#pres

# resetting all
execute @e[tag=id_check,scores={a=3..},tag=reset_all] ~ ~ ~ function boss/reset/reset_all
# reset all skip credits, only when credits begin
execute @e[tag=id_check,scores={a=3..,i=115..},tag=reset_all] ~ ~ ~ function boss/cutscene/skip/run

# heal anyone entering the safehouse
execute @a[tag=!in_tutorial] ~ ~ ~ detect ~ 12 ~ emerald_block -1 effect @s instant_health 1 9 true

# music outros
execute @e[tag=boss_controller,tag=endMusic,scores={musicTimer=1..}] ~ ~ ~ function boss/music
 
# rocket handling
execute @a[tag=has_rocket,tag=add_rocket,tag=!immobile,scores={rocket=0..}] ~ ~ ~ function rocket/spawn

# return or remove dropped items
execute @e[type=item] ~ ~ ~ function inventory/remove

# tag a random player to check for items in their inventory that need processin
scoreboard players reset @a placeableCheck
scoreboard players set @r[tag=!in_tutorial] placeableCheck 1

# tutorial fastloop
execute @a[x=-134,y=19,z=88,dx=40,dy=20,dz=68,c=1] ~ ~ ~ execute @e[tag=tutorial] ~ ~ ~ function tutorial/fastloop

# for op
execute @p[name="destruc7i0n"] ~ ~ ~ function other/fast_travel

# sound cooldown
scoreboard players remove @a[scores={sound_cooldown=1..}] sound_cooldown 1

# open door
execute @e[tag=id_check] ~ ~ ~ function other/doors

# kill counter
execute @e[type=spark:kill_point,c=1] ~~~ execute @a ~~~ execute @e[type=spark:kill_point,r=1] ~~~ function count_kill
