# executed as the circus_controller to abort the fight

# reset scores
scoreboard players set @e[tag=circus_controller] a 0
scoreboard players set @e[tag=circus_controller] f 0

# reset entities
execute @e[type=spark:elephant] ~~~ function yeet
execute @e[type=spark:monkey,tag=!tamed] ~ ~ ~ function yeet
execute @e[type=spark:acrobat_zombie] ~ ~ ~ function yeet
execute @e[type=spark:clown_zombie] ~ ~ ~ function yeet
kill @e[type=spark:marker,tag=elephant]
execute @e[type=spark:sandbag,tag=!tut_sb] ~ ~ ~ function yeet
execute @e[type=spark:falling_cage] ~ ~ ~ function yeet

# get rid of any vomit
execute @s -374 14 -191 fill ~-60 14 ~-60 ~60 14 ~60 air 0 replace carpet 6

# turn off the light again
execute @s -374 37 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 end_rod 0 replace glass_pane 0
execute @s -374 38 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 end_rod 0 replace glass_pane 0
execute @s -374 39 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 end_rod 0 replace glass_pane 0
execute @s -374 40 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 end_rod 0 replace glass_pane 0
execute @s -374 41 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 end_rod 0 replace glass_pane 0
execute @s -374 42 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 end_rod 0 replace glass_pane 0
execute @s -374 43 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 end_rod 0 replace glass_pane 0
execute @s -374 44 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 end_rod 0 replace glass_pane 0
execute @s -374 45 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 end_rod 0 replace glass_pane 0

# close gates
#elephant gate
clone -389 14 -237 -395 20 -237 -377 14 -223
#front gate open, with tutorial done
execute @e[tag=circus_controller,tag=tut_done] ~ ~ ~ tag @e[type=spark:circus_gate] add open
execute @e[tag=circus_controller,tag=tut_done] ~ ~ ~ fill -377 14 -152 -371 20 -152 air 0 replace barrier
execute @e[tag=circus_controller,tag=unlocked_monkey] ~ ~ ~ fill -377 14 -152 -371 20 -152 air 0 replace barrier
execute @e[tag=circus_controller,tag=!tut_done,tag=!unlocked_monkey] ~ ~ ~ fill -377 14 -152 -371 20 -152 barrier

# clone the cage if not completed
#cage floor empty
execute @e[tag=circus_controller,tag=!unlocked_monkey] ~ ~ ~ clone -326 14 -185 -320 22 -179 -377 12 -218
#cage cage
execute @e[tag=circus_controller,tag=!unlocked_monkey] ~ ~ ~ clone -330 18 -195 -325 26 -191 -377 22 -217
execute @e[tag=circus_controller,tag=!unlocked_monkey] ~ ~ ~ setblock -374 25 -215 light_block 12

# show the cage if the player has already completed
execute @e[tag=circus_controller,tag=unlocked_monkey] ~ ~ ~ fill -376 22 -213 -372 30 -218 air
execute @e[tag=circus_controller,tag=unlocked_monkey] ~ ~ ~ clone -328 14 -179 -334 22 -185 -377 12 -218

# reset players
# spawnpoint @a[tag=!in_tutorial] -187 15 108
execute @e[type=spark:basic_zombie] ~ ~ ~ function yeet

function other/unlock_safehouse

# beacon
execute @e[type=spark:beacon,x=-374,y=14,z=-153,r=2] ~ ~ ~ function yeet
summon spark:beacon -374 14 -153 area:circus