# executed as the circus controller after fight has been won
scoreboard players set @e[tag=circus_controller] a 100
scoreboard players set @e[tag=circus_controller] f 0

# remove leftover entities
kill @e[type=spark:elephant]
execute @e[type=spark:acrobat_zombie] ~ ~ ~ function yeet
execute @e[type=spark:clown_zombie] ~ ~ ~ function yeet
kill @e[type=spark:marker,tag=elephant]
execute @e[type=spark:sandbag] ~ ~ ~ function yeet

execute @s -374 14 -191 fill ~-60 14 ~-60 ~60 14 ~60 air 0 replace carpet 6

# remove the endrods again
execute @s -374 37 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 end_rod 0 replace glass_pane 0
execute @s -374 38 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 end_rod 0 replace glass_pane 0
execute @s -374 39 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 end_rod 0 replace glass_pane 0
execute @s -374 40 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 end_rod 0 replace glass_pane 0
execute @s -374 41 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 end_rod 0 replace glass_pane 0
execute @s -374 42 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 end_rod 0 replace glass_pane 0
execute @s -374 43 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 end_rod 0 replace glass_pane 0
execute @s -374 44 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 end_rod 0 replace glass_pane 0
execute @s -374 45 -191 fill ~-60 ~ ~-60 ~60 ~ ~60 end_rod 0 replace glass_pane 0

scoreboard players add @e[tag=circus_controller] plays 1

#front gate empty
tag @e[type=spark:circus_gate] add open
fill -377 14 -152 -371 20 -152 air

#cage floor fallen
# clone -328 14 -179 -334 22 -185 -377 12 -218
#cage empty
# fill -372 30 -218 -376 22 -214 air
#safehouse monkey
tag @e[tag=display_monkey] add unlock

# 
# give @a[tag=!in_tutorial,tag=!in_safehouse] wheat 1 0
# tp @e[type=spark:monkey] -374 13 -215


# player feedback
playsound random.totem @a[tag=!in_tutorial,tag=!in_safehouse] ~ ~ ~ 1 0.8

title @a[tag=!in_tutorial,tag=!in_safehouse] times 0 80 120
title @a[tag=!in_tutorial,tag=!in_safehouse] subtitle §aYou beat the elephant.
title @a[tag=!in_tutorial,tag=!in_safehouse] title §a
execute @e[tag=circus_controller,tag=!unlocked_monkey] ~ ~ ~ function boss/notices
execute @e[tag=id_check,scores={a=2..}] ~ ~ ~ tag @e[type=spark:safehouse_map] add enable_townhall
# cage falling
execute @e[tag=circus_controller,tag=!unlocked_monkey] ~ ~ ~ function boss/circus/cutscene/cage/init

# music
tag @e[tag=circus_controller] add endMusic

# reset players
# spawnpoint @a[tag=!in_tutorial] -187 15 108

# tp @a[tag=spectator] -374 14 -160 180 0
execute @a[tag=spectator] ~ ~ ~ function boss/spectators/reset
tag @a[tag=spectator] remove spectator
tag @a remove make_spectator

tag @e[tag=id_check] add bossfight_completed

# do not run the circus cutscene if the player has won already
execute @e[tag=circus_controller,tag=unlocked_monkey] ~ ~ ~ function other/unlock_safehouse
execute @e[tag=circus_controller,tag=unlocked_monkey] ~ ~ ~ scoreboard players set @e[tag=circus_controller] a -1
# show the cage if the player has already completed
execute @e[tag=circus_controller,tag=unlocked_monkey] -374 24 -215 execute @e[type=spark:monkey,r=5] ~ ~ ~ function yeet
execute @e[tag=circus_controller,tag=unlocked_monkey] ~ ~ ~ fill -376 22 -213 -372 30 -218 air
execute @e[tag=circus_controller,tag=unlocked_monkey] ~ ~ ~ clone -328 14 -179 -334 22 -185 -377 12 -218

tag @e[type=spark:safehouse_map] add lock_circus