# execute as junkyard_controller when win condition happens

# set the fight to done
scoreboard players set @e[tag=junkyard_controller] a -1

# remove leftover pickup items and close the beacons
kill @e[type=spark:tire_stack]
kill @e[type=spark:fuel_can]
kill @e[type=spark:truck_engine]
kill @e[type=spark:truck_spikes]
setblock -220 13 108 dirt
setblock -248 13 109 dirt
setblock -212 6 79 cobblestone
setblock -255 19 37 gravel

# open entrance gate
clone -215 6 119 -209 10 114 -215 14 114
fill -210 14 115 -213 17 117 air 0 destroy
kill @e[type=item,x=-214,y=14,z=114,dx=5,dy=4,dz=3]
# open exit gate
# fill -225 9 14 -217 14 14 air
tag @e[type=spark:junkyard_gate] add open
particle spark:gate_explosion -221 11 14.9
# execute @a[tag=!in_tutorial,tag=!in_safehouse] ~ ~ ~ playsound scrapyarddoor.crashthrough @a

# add 1 for the armor replacer
execute @e[tag=junkyard_controller,tag=!unlocked_gate] ~ ~ ~ function boss/notices
# tell player what happened
title @a[tag=!in_tutorial,tag=!in_safehouse] times 0 80 120
title @a[tag=!in_tutorial,tag=!in_safehouse] subtitle §aYou have escaped!
title @a[tag=!in_tutorial,tag=!in_safehouse] title §a

tellraw @a[tag=!in_tutorial,tag=!in_safehouse] {"rawtext":[{"text":"§2§lTIP: §rGear up and collect loot by killing zombies."}]}
execute @e[tag=id_check] ~ ~ ~ function other/messages/randomize_time

execute @e[tag=id_check,scores={a=2..}] ~ ~ ~ tag @e[type=spark:safehouse_map] add enable_townhall

scoreboard players add @e[tag=junkyard_controller] plays 1

tag @e[tag=junkyard_controller] add unlocked_gate

# safehouse car button
clone -171 7 107 -171 9 108 -186 13 125

# remove blocking cars from garage 
setblock -209 17 131 air
clone -153 8 85 -165 4 89 -213 14 126
clone -164 4 57 -156 8 64 -221 14 138
setblock -201 14 131 air
setblock -200 14 130 air
setblock -211 16 131 air

# reset players
# spawnpoint @a[tag=!in_tutorial,tag=!in_safehouse] -187 15 108

spreadplayers -219 30 1 3 @a[tag=spectator]
execute @a[tag=spectator] ~ ~ ~ function boss/spectators/reset
tag @a[tag=spectator] remove spectator
tag @a remove make_spectator

function other/unlock_safehouse

tag @e[type=spark:safehouse_map] add lock_junkyard

# music
tag @e[tag=junkyard_controller] add endMusic