# cutscene path with constant teleportation
execute @s[scores={cutscene=0..799}] ~ ~ ~ function boss/pplant/cutscene/constant_path

# remove zombies in the center
execute @s[scores={cutscene=0..799}] -419 14 360 function other/bulk_zombies/yeet_nearby_zombies

#end
execute @s[scores={cutscene=800}] ~ ~ ~ function boss/pplant/cutscene/end
execute @s[tag=skip_cutscene] ~~~ function boss/pplant/cutscene/end

# the clone command seems to bring a lot of lag...

# bring in the light blocks
execute @s[scores={cutscene=270}] ~ ~ ~ clone -442 5 337 -396 6 383 -442 14 337 filtered normal light_block -1

#generator1
execute @s[scores={cutscene=271}] ~ ~ ~ clone -442 5 337 -396 5 383 -442 14 337 filtered normal stained_glass_pane 6
execute @s[scores={cutscene=271}] ~ ~ ~ function boss/pplant/generator/1a
execute @s[scores={cutscene=271}] ~ ~ ~ title @a[tag=in_cutscene] times 0 40 50 
execute @s[scores={cutscene=271}] ~ ~ ~ title @a[tag=in_cutscene] subtitle §eGenerator A
execute @s[scores={cutscene=271}] ~ ~ ~ title @a[tag=in_cutscene] title §a
execute @s[scores={cutscene=271}] ~ ~ ~ tellraw @a[tag=in_cutscene] {"rawtext":[{"text":"§e§l[!] §r§eEach generator powers §rthe scientists §eshield§r."}]}
#generator2
execute @s[scores={cutscene=390}] ~ ~ ~ clone -442 6 337 -396 6 383 -442 15 337 filtered normal stained_glass_pane 6
execute @s[scores={cutscene=390}] ~ ~ ~ function boss/pplant/generator/1c
execute @s[scores={cutscene=390}] ~ ~ ~ title @a[tag=in_cutscene] times 0 40 50 
execute @s[scores={cutscene=390}] ~ ~ ~ title @a[tag=in_cutscene] subtitle §eGenerator B
execute @s[scores={cutscene=390}] ~ ~ ~ title @a[tag=in_cutscene] title §a
execute @s[scores={cutscene=390}] ~ ~ ~ tellraw @a[tag=in_cutscene] {"rawtext":[{"text":"§e§l[!] §r§eFlick the levers §rto turn each generator §cOFF§r."}]}
#generator3
execute @s[scores={cutscene=524}] ~ ~ ~ clone -442 7 337 -396 8 383 -442 16 337 filtered normal stained_glass_pane 6
execute @s[scores={cutscene=524}] ~ ~ ~ function boss/pplant/generator/1b
execute @s[scores={cutscene=524}] ~ ~ ~ title @a[tag=in_cutscene] times 0 40 50 
execute @s[scores={cutscene=524}] ~ ~ ~ title @a[tag=in_cutscene] subtitle §eGenerator C
execute @s[scores={cutscene=524}] ~ ~ ~ title @a[tag=in_cutscene] title §a
# execute @s[scores={cutscene=524}] ~ ~ ~ tellraw @a[tag=in_cutscene] {"rawtext":[{"text":"§eWhen all 3 are §cOFF§e, the §ashield §eturns off."}]}
#scientist landing sequence
execute @s[scores={cutscene=624}] ~ ~ ~ summon spark:scientist -419 120 360
execute @s[scores={cutscene=624}] ~ ~ ~ scoreboard players set @e[type=spark:scientist] a 1
execute @s[scores={cutscene=624}] ~ ~ ~ tp @e[type=spark:scientist] -419 120 360 180 0
execute @s[scores={cutscene=624}] ~ ~ ~ playsound scientist.spawn @a[tag=in_cutscene] 
execute @s[scores={cutscene=624}] ~ ~ ~ tellraw @a[tag=in_cutscene] {"rawtext":[{"text":"§6§l[!] §r§6Flick the levers to disable the scientists shield."}]}

# add and remove the spectator region
execute @s[scores={cutscene=600}] ~ ~ ~ fill -416 29 363 -422 33 357 air 0
execute @s[scores={cutscene=688}] ~ ~ ~ fill -416 29 363 -422 33 357 barrier 0 hollow

execute @s[scores={cutscene=655}] ~ ~ ~ tag @e[type=spark:scientist] add landing
execute @s[scores={cutscene=690}] ~ ~ ~ tag @e[type=spark:scientist] remove landing

execute @s[scores={cutscene=688}] ~ ~ ~ tag @e[type=spark:scientist] add sized
execute @s[scores={cutscene=688}] ~ ~ ~ playsound ambient.weather.lightning.impact @a[tag=in_cutscene] -419 13 360 1 0.4 1

execute @s[scores={cutscene=670}] ~ ~ ~ tag @e[type=spark:scientist] add invul
execute @s[scores={cutscene=710}] ~ ~ ~ tag @e[type=spark:scientist] add attack_p
execute @s[scores={cutscene=710}] ~ ~ ~ tag @e[type=spark:scientist] add attack_0
execute @s[scores={cutscene=715}] ~ ~ ~ tag @e[type=spark:scientist] remove attack_0

# brighten the light blocks
execute @s[scores={cutscene=710}] ~ ~ ~ fill -442 14 383 -396 15 337 light_block 14 replace light_block

# begin the particles for the boss
execute @s[scores={cutscene=675..800}] ~ ~ ~ function boss/pplant/check_levers

#other
effect @a[tag=in_cutscene] invisibility 1 0 true
scoreboard players add @s cutscene 1
