# a is roof -> tutorial elevator
# -184 46 145 / -182 46 144
# b is tutorial exit elevator
# -90 28 140 / -90 28 139
# c is tutorial -> safehouse elevator
# -112 21 86 / -112 21 89
# d is safehouse elevator
# -188 15 105 / -188 15 96

# count up/down if players are/aren't in elevator
execute @a[x=-184,y=46,z=145,dx=2,dy=2,dz=2,c=1] ~ ~ ~ scoreboard players add @e[tag=elevator,scores={a=..5}] a 2
execute @a[x=-90,y=28,z=140,dx=2,dy=2,dz=2,c=1] ~ ~ ~ scoreboard players remove @e[tag=elevator,scores={b=1..}] b 2
execute @a[x=-112,y=21,z=86,dx=2,dy=2,dz=2,c=1] ~ ~ ~ scoreboard players add @e[tag=elevator,scores={c=..5}] c 2
execute @a[x=-112,y=21,z=86,dx=2,dy=2,dz=2,c=1,scores={item_0=-1}] ~ ~ ~ scoreboard players remove @e[tag=elevator,scores={c=3..7}] c 2
execute @a[x=-112,y=21,z=86,dx=2,dy=2,dz=2,c=1] ~ ~ ~ execute @a[x=-116,y=21,z=89,dx=10,dy=5,dz=19,c=1] ~ ~ ~ scoreboard players remove @e[tag=elevator,scores={c=3..7}] c 2
execute @a[x=-188,y=15,z=93,dx=2,dy=2,dz=2,c=1] ~ ~ ~ scoreboard players remove @e[tag=elevator,scores={d=1..}] d 2
scoreboard players remove @s[scores={a=1..}] a 1
scoreboard players add @s[scores={b=..5}] b 1
scoreboard players remove @s[scores={c=1..}] c 1
scoreboard players add @s[scores={d=..5}] d 1

# title for players to choose a kit first
execute @a[x=-112,y=21,z=86,dx=2,dy=2,dz=2,scores={item_0=-1}] ~ ~ ~ title @s times 0 40 20
execute @a[x=-112,y=21,z=86,dx=2,dy=2,dz=2,scores={item_0=-1}] ~ ~ ~ title @s subtitle §aChoose a starter kit first
execute @a[x=-112,y=21,z=86,dx=2,dy=2,dz=2,scores={item_0=-1}] ~ ~ ~ title @s title §a

# open/close doors and teleport players
execute @s[scores={a=1}] ~ ~ ~ fill -184 46 144 -182 48 144 air
execute @s[scores={a=2}] ~ ~ ~ fill -182 46 144 -182 48 144 observer 5
execute @s[scores={a=2}] ~ ~ ~ playsound elevator.closing1 @a[x=-183,y=46,z=144,r=15] -183 46 144
execute @s[scores={a=2}] ~ ~ ~ execute @a[x=-182,y=46,z=144,dx=0,dy=1,dz=0] ~ ~ ~ tp @s ~ ~ ~1 
execute @s[scores={a=2}] ~ ~ ~ fill -184 46 144 -183 48 144 air
execute @s[scores={a=3}] ~ ~ ~ fill -183 46 144 -182 48 144 observer 5
execute @s[scores={a=3}] ~ ~ ~ playsound elevator.closing2 @a[x=-183,y=46,z=144,r=15] -183 46 144
execute @s[scores={a=3}] ~ ~ ~ fill -184 46 144 -184 48 144 air
execute @s[scores={a=3}] ~ ~ ~ execute @a[x=-183,y=46,z=144,dx=0,dy=1,dz=0] ~ ~ ~ tp @s ~ ~ ~1 
execute @s[scores={a=4}] ~ ~ ~ fill -184 46 144 -182 48 144 observer 5
execute @s[scores={a=4}] ~ ~ ~ playsound elevator.closing3 @a[x=-183,y=46,z=144,r=15] -183 46 144
execute @s[scores={a=4}] ~ ~ ~ execute @a[x=-184,y=46,z=144,dx=0,dy=1,dz=0] ~ ~ ~ tp @s ~ ~ ~1 
execute @s[scores={a=6}] ~ ~ ~ playsound elevator.moving @a[x=-183,y=46,z=144,r=15] -183 46 144
execute @s[scores={a=6}] ~ ~ ~ execute @a[x=-184,y=46,z=145,dx=2,dy=2,dz=2] ~ ~ ~ tp @s ~94 ~-18 ~-5

execute @s[scores={b=5}] ~ ~ ~ fill -90 28 139 -88 30 139 observer 5
execute @s[scores={b=5}] ~ ~ ~ execute @a[x=-90,y=28,z=139,dx=0,dy=1,dz=0] ~ ~ ~ tp @s ~ ~ ~-1 
execute @s[scores={b=4}] ~ ~ ~ fill -89 28 139 -88 30 139 observer 5
execute @s[scores={b=4}] ~ ~ ~ playsound elevator.closing1 @a[x=-89,y=28,z=139,r=15] -89 28 139
execute @s[scores={b=4}] ~ ~ ~ fill -90 28 139 -90 30 139 air
execute @s[scores={b=4}] ~ ~ ~ execute @a[x=-89,y=28,z=139,dx=0,dy=1,dz=0] ~ ~ ~ tp @s ~ ~ ~-1 
execute @s[scores={b=3}] ~ ~ ~ playsound elevator.closing2 @a[x=-89,y=28,z=139,r=15] -89 28 139
execute @s[scores={b=3}] ~ ~ ~ fill -88 28 139 -88 30 139 observer 5
execute @s[scores={b=3}] ~ ~ ~ fill -90 28 139 -89 30 139 air
execute @s[scores={b=2}] ~ ~ ~ playsound elevator.closing3 @a[x=-89,y=28,z=139,r=15] -89 28 139
execute @s[scores={b=3}] ~ ~ ~ execute @a[x=-88,y=28,z=139,dx=0,dy=1,dz=0] ~ ~ ~ tp @s ~ ~ ~-1 
execute @s[scores={b=2}] ~ ~ ~ fill -90 28 139 -88 30 139 air

execute @s[scores={c=1}] ~ ~ ~ fill -112 21 89 -110 23 89 air
execute @s[scores={c=2}] ~ ~ ~ fill -112 21 89 -112 23 89 observer 4
execute @s[scores={c=2}] ~ ~ ~ playsound elevator.closing1 @a[x=-111,y=21,z=89,r=15] -111 21 89
execute @s[scores={c=2}] ~ ~ ~ fill -111 21 89 -110 23 89 air
execute @s[scores={c=3}] ~ ~ ~ fill -112 21 89 -111 23 89 observer 4
execute @s[scores={c=3}] ~ ~ ~ playsound elevator.closing2 @a[x=-111,y=21,z=89,r=15] -111 21 89
execute @s[scores={c=3}] ~ ~ ~ fill -110 21 89 -110 23 89 air
execute @s[scores={c=4}] ~ ~ ~ fill -112 21 89 -110 23 89 observer 4
execute @s[scores={c=4}] ~ ~ ~ playsound elevator.closing3 @a[x=-111,y=21,z=89,r=15] -111 21 89
execute @s[scores={c=6}] ~ ~ ~ playsound elevator.moving @a[x=-111,y=21,z=89,r=15] -111 21 89
execute @s[scores={c=6}] ~ ~ ~ tellraw @a[tag=in_tutorial] {"rawtext":[{"text":"§2§lTIP: §rFind better weapons in loot drops. Anything is better than a piece of wood..."}]}
execute @s[scores={c=6}] ~ ~ ~ scoreboard objectives setdisplay sidebar zombieKills
execute @s[scores={c=6}] ~ ~ ~ execute @a[x=-112,y=21,z=86,dx=2,dy=2,dz=2] ~ ~ ~ function tutorial/done

execute @s[scores={d=5}] ~ ~ ~ fill -188 15 96 -186 17 96 observer 4
execute @s[scores={d=5}] ~ ~ ~ execute @a[x=-186,y=15,z=96,dx=0,dy=1,dz=0] ~ ~ ~ tp @s ~ ~ ~1
execute @s[scores={d=4}] ~ ~ ~ playsound elevator.closing1 @a[x=-187,y=15,z=96,r=15] -187 15 96
execute @s[scores={d=4}] ~ ~ ~ fill -188 15 96 -187 17 96 observer 4
execute @s[scores={d=4}] ~ ~ ~ fill -186 15 96 -186 17 96 air
execute @s[scores={d=4}] ~ ~ ~ execute @a[x=-187,y=15,z=96,dx=0,dy=1,dz=0] ~ ~ ~ tp @s ~ ~ ~1
execute @s[scores={d=3}] ~ ~ ~ playsound elevator.closing2 @a[x=-187,y=15,z=96,r=15] -187 15 96
execute @s[scores={d=3}] ~ ~ ~ fill -188 15 96 -188 17 96 observer 4
execute @s[scores={d=3}] ~ ~ ~ fill -187 15 96 -186 17 96 air
execute @s[scores={d=3}] ~ ~ ~ execute @a[x=-188,y=15,z=96,dx=0,dy=1,dz=0] ~ ~ ~ tp @s ~ ~ ~1
execute @s[scores={d=2}] ~ ~ ~ playsound elevator.closing3 @a[x=-187,y=15,z=96,r=15] -187 15 96
execute @s[scores={d=2}] ~ ~ ~ fill -188 15 96 -186 17 96 air

# particles
execute @s[scores={a=0..2}] ~ ~ ~ particle spark:elevator -183 46.1 146
execute @s[scores={c=0..2}] ~ ~ ~ particle spark:elevator -111 21.1 87

# rooftop start text
particle spark.zombies:rooftop.start.north -183 48 144