# a: flag whether mower is in non-transparent block
# b: flag whether mower has air below it
# c: timer that controls for how long... it's falling? or something I'm really not too sure.

# check if mower is on the ground, teleport down if it isn't, teleport forward if it is.
scoreboard players remove @s c 1
scoreboard players set @s b 0
execute @s ~ ~ ~ detect ~ ~-.1 ~ air -1 scoreboard players set @s b 1
tp @s[scores={b=0}] ^ ^ ^-.16
tp @s[scores={b=1,c=..0}] ^ ^-.1 ^-.1
scoreboard players set @s[scores={b=1,c=..0}] c 15

# kill mower after 4.5 seconds of being on the ground
scoreboard players add @s[scores={b=0}] check 1
execute @s[scores={check=90..}] ~ ~ ~ function yeet

# deal damage to adjacent enemies
effect @e[type=spark:acrobat_zombie,r=2] instant_damage 1 0 true
effect @e[type=spark:agent_zombie,r=2] instant_damage 1 0 true
effect @e[type=spark:basic_zombie,r=2] instant_damage 1 0 true
effect @e[type=spark:clown_zombie,r=2] instant_damage 1 0 true
effect @e[type=spark:dummy_zombie,r=2] instant_damage 1 0 true
effect @e[type=spark:elephant,r=2] instant_damage 1 0 true
effect @e[type=spark:fat_zombie,r=2] instant_damage 1 0 true
effect @e[type=spark:jetpack_zombie,r=2] instant_damage 1 0 true
effect @e[type=spark:military_zombie,r=2] instant_damage 1 0 true
effect @e[type=spark:president_zombie,r=2] instant_damage 1 0 true
effect @e[type=spark:segway_zombie,r=2] instant_damage 1 0 true
effect @e[type=spark:scientist,r=2] instant_damage 1 0 true
effect @e[type=spark:tank_zombie,r=2] instant_damage 1 0 true
effect @e[type=spark:tnt_zombie,r=2] instant_damage 1 0 true
effect @e[type=spark:vomit_zombie,r=2] instant_damage 1 0 true
effect @e[type=spark:zombee,r=2] instant_damage 1 0 true
effect @e[type=spark:zombie_head,r=2] instant_damage 1 0 true

# kill mower if it runs into a non-transparent block
scoreboard players set @s a 0
execute @s ~ ~ ~ detect ~ ~ ~ air -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ tallgrass -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ web -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ double_plant -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ red_flower -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ yellow_flower -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ vine -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ wooden_button -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ stone_button -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ light_weighted_pressure_plate -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ heavy_weighted_pressure_plate -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ wooden_pressure_plate -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ stone_pressure_plate -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ lever -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ standing_sign -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ wall_sign -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ trapdoor -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ iron_trapdoor -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ standing_banner -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ wall_banner -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ rail -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ ladder -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ tripwire_hook -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ torch -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ redstone_torch -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ unlit_redstone_torch -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ redstone_wire -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ unpowered_repeater -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ powered_repeater -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ unpowered_comparator -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ powered_comparator -1 scoreboard players set @s a 1
execute @s ~ ~ ~ detect ~ ~ ~ carpet -1 scoreboard players set @s a 1
execute @s[scores={a=0}] ~ ~ ~ function yeet